// Generated by LiveScript 1.5.0
var RegexSearch, StringSearch, TextStreamAccumulator, debug, TextStreamSearch, toString$ = {}.toString;
RegexSearch = require('./regex-search');
StringSearch = require('./string-search');
TextStreamAccumulator = require('text-stream-accumulator');
debug = require('debug')('text-stream-search');
TextStreamSearch = (function(){
  TextStreamSearch.displayName = 'TextStreamSearch';
  var prototype = TextStreamSearch.prototype, constructor = TextStreamSearch;
  function TextStreamSearch(stream){
    this._onStreamData = bind$(this, '_onStreamData', prototype);
    stream.on('data', this._onStreamData);
    this._searches = [];
    this._accumulator = new TextStreamAccumulator(stream);
  }
  TextStreamSearch.prototype.fullText = function(){
    return this._accumulator.toString();
  };
  TextStreamSearch.prototype.reset = function(){
    return this._accumulator.reset();
  };
  TextStreamSearch.prototype.wait = function(query, handler, timeout){
    debug("adding search for: " + query);
    this._searches.push(this._createSearchInstance(query, handler, timeout));
    return this._checkSearches();
  };
  TextStreamSearch.prototype._createSearchInstance = function(query, handler, timeout){
    var queryType;
    switch (queryType = toString$.call(query).slice(8, -1)) {
    case 'String':
      return new StringSearch({
        accumulator: this._accumulator,
        handler: handler,
        query: query,
        timeout: timeout
      });
    case 'RegExp':
      return new RegexSearch({
        accumulator: this._accumulator,
        handler: handler,
        query: query,
        timeout: timeout
      });
    default:
      throw new Error("unknown data type to wait for: " + queryType);
    }
  };
  TextStreamSearch.prototype._onStreamData = function(data){
    var this$ = this;
    debug("receiving text: '" + data.toString() + "'");
    return process.nextTick(function(){
      return this$._checkSearches();
    });
  };
  TextStreamSearch.prototype._checkSearches = function(){
    var text, i$, ref$, len$, search, results$ = [];
    text = this.fullText();
    for (i$ = 0, len$ = (ref$ = this._searches).length; i$ < len$; ++i$) {
      search = ref$[i$];
      results$.push(search.check(text));
    }
    return results$;
  };
  return TextStreamSearch;
}());
module.exports = TextStreamSearch;
function bind$(obj, key, target){
  return function(){ return (target || obj)[key].apply(obj, arguments) };
}